Subject: RE: file_id

From: "Noveck, Dave" <[email-masked]>
Date: Mon, 2 Dec 2002 07:39:59 -0800

Carl Beame wrote: 
> On Sat Nov 30 13:40:28 2002, Jim Rees wrote:
> > I use the cookie.  For OpenBSD it really only needs to be unique within the
> > directory, so this works fine.  In fact I'm thinking of ignoring fileid and
> > always using the cookie, since fileid is not guaranteed unique, or even
> > present (as your own server so amply demonstrated to me at the last
> > bakeoff).
> > 
> My experience with the NFS v3 server for Windows is that the FileID is
> unique over the filesystem and if you don't adhere to this some very funny and
> bad things happen. Also you need to keep the FileId the same for the life of the
> mount. 

Our server does not guarantee uniqueness but conflicts are limited to a
few specific cases, so that it hasn't turned out to be a big issue in 
practice.

A file and it's snapshotted image turn out to have the same fileid.  This
means that if you try to recover a file via:

     cp .snapshot/hourly.0/SomePreciousFile .

Copy will tell you are copying a file over itself unless you delete
the target first.  So people do that and go on.  

On the other hand, if you failed on the following, you might be less
tolerant:

     cp dir1/SomeFile dir2/SomeOtherFile